/* lab_text -- return text description given item history */

/* global declarations */
#include "SFSCONFG.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include "sfs.h"
#include "label.h"

static char *getrec();

char	*lab_text(filename,hist,sub0,sub1)
char	*filename;
char	*hist;
char	*sub0,*sub1;
{
	FILE		*ip;
	int32		mstart,mend,cstart,cend;
	int		mmax,cmax;
	struct stat	st;
	time_t		tim;
	char		*rec,*h,*e,*getrec(),c;
	char		prog[32];
	int		lo,hi,md,numrec;
	int		m,i;
	int32		pos;

	/* try and open file */
	if ((ip=fopen(filename,"r"))==NULL) {
/*		fprintf(stderr,"lab_match: failed to open labels file '%s'\n",filename); */
		return(NULL);
	}

	/* get info line */
	if (fscanf(ip,"#prolab %ld %d %d %d %d %d %d",&tim,&mstart,&mend,&mmax,&cstart,&cend,&cmax) != 7) {
		fprintf(stderr,"lab_match: bad labels file '%s'\n",filename);
		fclose(ip);
		return(NULL);
	}
#ifdef DOS
	mmax++;		/* account for CR + LF in DOS */
	cmax++;		/* account for CR + LF in DOS */
#endif

	/* get modification time of file */
	stat(filename,&st);
	if ((long)st.st_mtime > (long)(tim+5)) {
		fprintf(stderr,"lab_match: out of date labels file '%s'\n",filename);
		fprintf(stderr,"file time=%ld internal time=%ld\n",(long)st.st_mtime,(long)tim);
		fclose(ip);
		return(NULL);
	}

	/* find first and last entries */
	numrec = ((mend-mstart)/mmax) - 1;

	/* get program part of name */
	i=0;
	while (isalnum(hist[i])) {
		prog[i]=hist[i];
		i++;
	}
	prog[i]='\0';

	/* binary chop */
	lo=0;
	hi=numrec;
	do {
		md=(hi+lo)/2;
		rec=getrec(ip,mstart+md*mmax,&pos);
		if ((m=strcmp(prog,rec)) < 0)
			hi=md-1;
		else if (m > 0)
			lo=md+1;
	} while (!((m == 0) || (lo > hi)));

	/* check something found */
	if (m) {
		fclose(ip);
		return(NULL);
	}

	/* run back to find first */
	while ((m==0) && (md > 0)) {
		md--;
		rec=getrec(ip,mstart+md*mmax,&pos);
		m = strcmp(prog,rec);
	}
	if (m != 0) md++;

	/* run forward until no further match */
	e = &lab_hold[MAXSTRING];
	rec=getrec(ip,mstart+md*mmax,&pos);
	while ((md <= numrec) && (strcmp(prog,rec)==0)) {
		fseek(ip,pos,0);
		h = lab_hold;
		while (((c=getc(ip)) != ':') && (c != EOF) && (h < e)) *h++ = c;
		*h='\0';
		if (sub0) *sub0='\0';
		if (sub1) *sub1='\0';
		if (histmatch(lab_hold,hist,sub0,sub1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL)==1) {
			h = lab_hold;
			while (((c=getc(ip)) != ':') && (c != EOF) && (h < e)) *h++ = c;
			*h='\0';
			fclose(ip);
			return(lab_hold);
		}
		md++;
		rec=getrec(ip,mstart+md*mmax,&pos);
	}

	fclose(ip);

	return(NULL);
}

static char *getrec(ip,start,pos)
FILE		*ip;
int32		start;
int32		*pos;
{
	static char line[256];
	register char	*p;

	fseek(ip,start,0);
	fgets(line,256,ip);
	line[strlen(line)-1]='\0';
#ifdef IAG
fprintf(stderr,"at %d, line='%s'\n",start,line);
#endif
	*pos = atoi(&line[1]);
	p = &line[8];
	while (*p && (*p != '#')) p++;
	*p='\0';
	return(&line[8]);
}

#ifdef IAG
main()
{
	char	filename[80];
	char	code[80],sub0[80],sub1[80];
	char	*match;

	printf("Enter label filename : ");
	fflush(stdout);
	scanf("%s",filename);

	for (;;) {
		strcpy(match,"");
		strcpy(sub0,"");
		strcpy(sub1,"");
		printf("Enter history field : ");
		fflush(stdout);
		if (scanf("%s",code)!=1) break;
		match = lab_text(filename,code,sub0,sub1);
		printf("match='%s'\n",match);
		printf("sub0 ='%s'\n",sub0);
		printf("sub1 ='%s'\n",sub1);
	}
}
#endif
